from libcpp cimport bool as c_bool
from libcpp.string cimport string as c_string
from escape.core.setting cimport int_setting_t
from escape.core.functor cimport cplx_functor_t, functor_t, parameter_t
from escape.core.variable cimport variable_t
from escape.scattering.layer cimport multilayer_t
from escape.core.math cimport vector_t
        

cdef extern from "escape/scattering.h" namespace "escape":
    cplx_functor_t cpp_polnreftrans_rm_v "escape::polnreftrans_rm" (
        c_string, variable_t, multilayer_t, int_setting_t, vector_t, parameter_t, parameter_t)
    cplx_functor_t cpp_polnreftrans_tm_v "escape::polnreftrans_tm" (
        c_string, variable_t, multilayer_t, int_setting_t, vector_t, parameter_t, parameter_t)
    cplx_functor_t cpp_polnreftrans_kz_v "escape::polnreftrans_kz" (
        c_string, variable_t, multilayer_t, int_setting_t, vector_t, parameter_t, parameter_t)
    
    cplx_functor_t cpp_polnreftrans_rm_f "escape::polnreftrans_rm" (
        c_string, functor_t, multilayer_t, int_setting_t, vector_t, parameter_t, parameter_t)
    cplx_functor_t cpp_polnreftrans_tm_f "escape::polnreftrans_tm" (
        c_string, functor_t, multilayer_t, int_setting_t, vector_t, parameter_t, parameter_t)
    cplx_functor_t cpp_polnreftrans_kz_f "escape::polnreftrans_kz" (
        c_string, functor_t, multilayer_t, int_setting_t, vector_t, parameter_t, parameter_t)
    cplx_functor_t cpp_polnreftrans_sm_f "escape::polnreftrans_sm" (
        c_string, functor_t, functor_t, multilayer_t, vector_t, parameter_t, parameter_t)
    functor_t cpp_polnreftrans_wn_f "escape::polnreftrans_wn" (
        c_string, functor_t, functor_t, multilayer_t, vector_t, parameter_t, parameter_t)
    