from libcpp cimport bool as c_bool
from libcpp.string cimport string as c_string

from escape.scattering.potential cimport potential_t
from escape.core.functor cimport functor_t
from escape.core.variable cimport variable_t
from escape.core.parameter cimport parameter_t
from escape.core.setting cimport int_setting_t




cdef extern from "escape/scattering.h" namespace "escape":
    functor_t cpp_generic_sas3d "escape::sas3d" (c_string, variable_t, variable_t, variable_t, 
                                         potential_t, functor_t) except+    
    functor_t cpp_descrete1d_sas3d "escape::sas3d" (c_string, variable_t, variable_t, variable_t, 
                                         potential_t, parameter_t, functor_t) except+
    functor_t cpp_descrete2d_sas3d "escape::sas3d" (c_string, variable_t, variable_t, variable_t, 
                                         potential_t, parameter_t, parameter_t, functor_t) except+