from libcpp cimport bool as c_bool
from libcpp.string cimport string as c_string

from escape.core.functor cimport functor_t
from escape.core.variable cimport variable_t
from escape.core.parameter cimport parameter_t
from escape.core.setting cimport int_setting_t, bool_setting_t

cdef extern from "escape/scattering.h" namespace "escape":

    functor_t cpp_hard_sphere "escape::hard_sphere" (
            c_string, variable_t, parameter_t, parameter_t) except+
            
    functor_t cpp_steaky_hard_sphere "escape::steaky_hard_sphere" (
            c_string, variable_t, parameter_t, parameter_t, parameter_t) except+
            
    functor_t cpp_polycrystal "escape::polycrystal" (
            c_string, variable_t, parameter_t, parameter_t, int_setting_t, bool_setting_t) except+
            
    functor_t cpp_polycr_bkgr "escape::polycr_bkgr" (
            c_string, variable_t, parameter_t, parameter_t, int_setting_t) except+
    
    