from libcpp cimport bool as c_bool
from libcpp.string cimport string as c_string

from escape.core.functor cimport functor_t
from escape.core.variable cimport variable_t
from escape.core.parameter cimport parameter_t
from escape.core.setting cimport int_setting_t

cdef extern from "escape/scattering.h" namespace "escape":
    functor_t cpp_lattice_1d "escape::lattice" (
            c_string, variable_t, parameter_t, int_setting_t) except+
    
    functor_t cpp_lattice_2d "escape::lattice" (
            c_string, variable_t, variable_t, parameter_t, parameter_t, 
            int_setting_t, int_setting_t) except+

   