from libcpp cimport bool as c_bool
from libcpp.string cimport string as c_string
from escape.core.setting cimport int_setting_t
from escape.core.functor cimport cplx_functor_t, functor_t
from escape.core.variable cimport variable_t
from escape.scattering.layer cimport multilayer_t
        

cdef extern from "escape/scattering.h" namespace "escape":
    cplx_functor_t cpp_reftrans_rm_v "escape::reftrans_rm" (c_string, variable_t, multilayer_t, int_setting_t)
    cplx_functor_t cpp_reftrans_tm_v "escape::reftrans_tm" (c_string, variable_t, multilayer_t, int_setting_t)
    cplx_functor_t cpp_reftrans_kz_v "escape::reftrans_kz" (c_string, variable_t, multilayer_t, int_setting_t)
    
    cplx_functor_t cpp_reftrans_rm_f "escape::reftrans_rm" (c_string, functor_t, multilayer_t, int_setting_t)
    cplx_functor_t cpp_reftrans_tm_f "escape::reftrans_tm" (c_string, functor_t, multilayer_t, int_setting_t)
    cplx_functor_t cpp_reftrans_kz_f "escape::reftrans_kz" (c_string, functor_t, multilayer_t, int_setting_t)
    cplx_functor_t cpp_reftrans_wf_f "escape::reftrans_wf" (c_string, functor_t, functor_t, multilayer_t)
    