from libcpp cimport bool as c_bool
from libcpp.string cimport string as c_string

from escape.scattering.layer cimport multilayer_t
from escape.core.functor cimport functor_t
from escape.core.variable cimport variable_t
from escape.core.setting cimport int_setting_t, double_setting_t

cdef extern from "escape/scattering.h" namespace "escape":
    functor_t cpp_spechrxrd_dynamic4x4 "escape::spechrxrd_dynamic4x4" (
                       c_string, variable_t, multilayer_t, int_setting_t,
                       int_setting_t, int_setting_t, double_setting_t) except+
                       
    functor_t cpp_spechrxrd_dynamic2x2 "escape::spechrxrd_dynamic2x2" (
                       c_string, variable_t, multilayer_t, int_setting_t,
                       int_setting_t, int_setting_t, double_setting_t) except+    
    
    
   